Index: trunk/examples/extended/electromagnetic/TestEm5/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/DetectorConstruction.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: DetectorConstruction.cc,v 1.13 2006/09/25 17:06:29 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: DetectorConstruction.cc,v 1.15 2009/01/22 17:41:43 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -46,4 +46,5 @@
 #include "G4UnitsTable.hh"
 #include "G4NistManager.hh"
+#include "G4RunManager.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -88,153 +89,154 @@
 void DetectorConstruction::DefineMaterials()
 { 
- //This function illustrates the possible ways to define materials
+  //This function illustrates the possible ways to define materials
  
-G4String symbol;             //a=mass of a mole;
-G4double a, z, density;      //z=mean number of protons;  
-
-G4int ncomponents, natoms;
-G4double fractionmass;
-G4double temperature, pressure;
-
-//
-// define Elements
-//
-
-G4Element* H  = new G4Element("Hydrogen",symbol="H",  z= 1, a=   1.01*g/mole);
-G4Element* C  = new G4Element("Carbon",  symbol="C",  z= 6, a=  12.01*g/mole);
-G4Element* N  = new G4Element("Nitrogen",symbol="N",  z= 7, a=  14.01*g/mole);
-G4Element* O  = new G4Element("Oxygen",  symbol="O",  z= 8, a=  16.00*g/mole);
-G4Element* Na = new G4Element("Sodium",  symbol="Na", z=11, a=  22.99*g/mole);
-G4Element* Ar = new G4Element("Argon",   symbol="Ar", z=18, a=  39.95*g/mole);
-G4Element* I  = new G4Element("Iodine",  symbol="I" , z=53, a= 126.90*g/mole);
-G4Element* Xe = new G4Element("Xenon",   symbol="Xe", z=54, a= 131.29*g/mole);
-
-//
-// define simple materials
-//
-
-new G4Material("H2Liq"    , z= 1, a= 1.01*g/mole, density= 70.8*mg/cm3);
-new G4Material("Beryllium", z= 4, a= 9.01*g/mole, density= 1.848*g/cm3);
-new G4Material("Aluminium", z=13, a=26.98*g/mole, density= 2.700*g/cm3);
-new G4Material("Silicon"  , z=14, a=28.09*g/mole, density= 2.330*g/cm3);
-
-G4Material* lAr = 
-new G4Material("liquidArgon", density= 1.390*g/cm3, ncomponents=1);
-lAr->AddElement(Ar, natoms=1);
-
-new G4Material("Iron",     z=26, a= 55.85*g/mole, density= 7.870*g/cm3);
-new G4Material("Copper",   z=29, a= 63.55*g/mole, density= 8.960*g/cm3);
-new G4Material("Silver",   z=47, a=107.87*g/mole, density= 10.50*g/cm3);
-new G4Material("Tungsten", z=74, a=183.85*g/mole, density= 19.30*g/cm3);
-new G4Material("Gold",     z=79, a=196.97*g/mole, density= 19.32*g/cm3);
-new G4Material("Lead",     z=82, a=207.19*g/mole, density= 11.35*g/cm3);
-
-//
-// define a material from elements.   case 1: chemical molecule
-//
-
-G4Material* H2O = new G4Material("Water", density= 1.000*g/cm3, ncomponents=2);
-H2O->AddElement(H, natoms=2);
-H2O->AddElement(O, natoms=1);
-H2O->GetIonisation()->SetMeanExcitationEnergy(75*eV);
-
-G4Material* CH = new G4Material("Plastic", density= 1.04*g/cm3, ncomponents=2);
-CH->AddElement(C, natoms=1);
-CH->AddElement(H, natoms=1);
-
-G4Material* NaI = new G4Material("NaI", density= 3.67*g/cm3, ncomponents=2);
-NaI->AddElement(Na, natoms=1);
-NaI->AddElement(I , natoms=1);
-NaI->GetIonisation()->SetMeanExcitationEnergy(452*eV);
-
-//
-// define a material from elements.   case 2: mixture by fractional mass
-//
-
-G4Material* Air = new G4Material("Air", density= 1.290*mg/cm3, ncomponents=2);
-Air->AddElement(N, fractionmass=0.7);
-Air->AddElement(O, fractionmass=0.3);
-
-G4Material* Air20 = 
-new G4Material("Air20", density= 1.205*mg/cm3, ncomponents=2,
-                        kStateGas, 293.*kelvin, 1.*atmosphere);
-Air20->AddElement(N, fractionmass=0.7);
-Air20->AddElement(O, fractionmass=0.3);
-
-//Graphite
-//
-G4Material* Graphite = 
-new G4Material("Graphite", density= 1.7*g/cm3, ncomponents=1);
-Graphite->AddElement(C, fractionmass=1.);
-
-//Havar
-//
-G4Element* Cr = new G4Element("Chrome", "Cr", z=25, a=  51.996*g/mole);
-G4Element* Fe = new G4Element("Iron"  , "Fe", z=26, a=  55.845*g/mole);
-G4Element* Co = new G4Element("Cobalt", "Co", z=27, a=  58.933*g/mole);
-G4Element* Ni = new G4Element("Nickel", "Ni", z=28, a=  58.693*g/mole);
-G4Element* W  = new G4Element("Tungsten","W", z=74, a= 183.850*g/mole);
-
-G4Material* Havar = 
-new G4Material("Havar", density= 8.3*g/cm3, ncomponents=5);
-Havar->AddElement(Cr, fractionmass=0.1785);
-Havar->AddElement(Fe, fractionmass=0.1822);
-Havar->AddElement(Co, fractionmass=0.4452);
-Havar->AddElement(Ni, fractionmass=0.1310);
-Havar->AddElement(W , fractionmass=0.0631);
-
-//
-// examples of gas
-//  
-new G4Material("ArgonGas", z=18, a=39.948*g/mole, density= 1.782*mg/cm3,
-                           kStateGas, 273.15*kelvin, 1*atmosphere);
+  G4String symbol;             //a=mass of a mole;
+  G4double a, z, density;      //z=mean number of protons;  
+
+  G4int ncomponents, natoms;
+  G4double fractionmass;
+  G4double temperature, pressure;
+  
+  //
+  // define Elements
+  //
+
+  G4Element* H  = new G4Element("Hydrogen",symbol="H",  z= 1, a=   1.01*g/mole);
+  G4Element* C  = new G4Element("Carbon",  symbol="C",  z= 6, a=  12.01*g/mole);
+  G4Element* N  = new G4Element("Nitrogen",symbol="N",  z= 7, a=  14.01*g/mole);
+  G4Element* O  = new G4Element("Oxygen",  symbol="O",  z= 8, a=  16.00*g/mole);
+  G4Element* Na = new G4Element("Sodium",  symbol="Na", z=11, a=  22.99*g/mole);
+  G4Element* Ar = new G4Element("Argon",   symbol="Ar", z=18, a=  39.95*g/mole);
+  G4Element* I  = new G4Element("Iodine",  symbol="I" , z=53, a= 126.90*g/mole);
+  G4Element* Xe = new G4Element("Xenon",   symbol="Xe", z=54, a= 131.29*g/mole);
+
+  //
+  // define simple materials
+  //
+
+  new G4Material("H2Liq"    , z= 1, a= 1.01*g/mole, density= 70.8*mg/cm3);
+  new G4Material("Beryllium", z= 4, a= 9.01*g/mole, density= 1.848*g/cm3);
+  new G4Material("Aluminium", z=13, a=26.98*g/mole, density= 2.700*g/cm3);
+  new G4Material("Silicon"  , z=14, a=28.09*g/mole, density= 2.330*g/cm3);
+
+  G4Material* lAr = 
+    new G4Material("liquidArgon", density= 1.390*g/cm3, ncomponents=1);
+  lAr->AddElement(Ar, natoms=1);
+
+  new G4Material("Iron",     z=26, a= 55.85*g/mole, density= 7.870*g/cm3);
+  new G4Material("Copper",   z=29, a= 63.55*g/mole, density= 8.960*g/cm3);
+  new G4Material("Germanium",z=32, a= 72.61*g/mole, density= 5.323*g/cm3);
+  new G4Material("Silver",   z=47, a=107.87*g/mole, density= 10.50*g/cm3);
+  new G4Material("Tungsten", z=74, a=183.85*g/mole, density= 19.30*g/cm3);
+  new G4Material("Gold",     z=79, a=196.97*g/mole, density= 19.32*g/cm3);
+  new G4Material("Lead",     z=82, a=207.19*g/mole, density= 11.35*g/cm3);
+
+  //
+  // define a material from elements.   case 1: chemical molecule
+  //
+
+  G4Material* H2O = new G4Material("Water", density= 1.000*g/cm3, ncomponents=2);
+  H2O->AddElement(H, natoms=2);
+  H2O->AddElement(O, natoms=1);
+  H2O->GetIonisation()->SetMeanExcitationEnergy(75*eV);
+
+  G4Material* CH = new G4Material("Plastic", density= 1.04*g/cm3, ncomponents=2);
+  CH->AddElement(C, natoms=1);
+  CH->AddElement(H, natoms=1);
+
+  G4Material* NaI = new G4Material("NaI", density= 3.67*g/cm3, ncomponents=2);
+  NaI->AddElement(Na, natoms=1);
+  NaI->AddElement(I , natoms=1);
+  NaI->GetIonisation()->SetMeanExcitationEnergy(452*eV);
+
+  //
+  // define a material from elements.   case 2: mixture by fractional mass
+  //
+
+  G4Material* Air = new G4Material("Air", density= 1.290*mg/cm3, ncomponents=2);
+  Air->AddElement(N, fractionmass=0.7);
+  Air->AddElement(O, fractionmass=0.3);
+
+  G4Material* Air20 = 
+    new G4Material("Air20", density= 1.205*mg/cm3, ncomponents=2,
+		   kStateGas, 293.*kelvin, 1.*atmosphere);
+  Air20->AddElement(N, fractionmass=0.7);
+  Air20->AddElement(O, fractionmass=0.3);
+
+  //Graphite
+  //
+  G4Material* Graphite = 
+    new G4Material("Graphite", density= 1.7*g/cm3, ncomponents=1);
+  Graphite->AddElement(C, fractionmass=1.);
+
+  //Havar
+  //
+  G4Element* Cr = new G4Element("Chrome", "Cr", z=25, a=  51.996*g/mole);
+  G4Element* Fe = new G4Element("Iron"  , "Fe", z=26, a=  55.845*g/mole);
+  G4Element* Co = new G4Element("Cobalt", "Co", z=27, a=  58.933*g/mole);
+  G4Element* Ni = new G4Element("Nickel", "Ni", z=28, a=  58.693*g/mole);
+  G4Element* W  = new G4Element("Tungsten","W", z=74, a= 183.850*g/mole);
+
+  G4Material* Havar = 
+    new G4Material("Havar", density= 8.3*g/cm3, ncomponents=5);
+  Havar->AddElement(Cr, fractionmass=0.1785);
+  Havar->AddElement(Fe, fractionmass=0.1822);
+  Havar->AddElement(Co, fractionmass=0.4452);
+  Havar->AddElement(Ni, fractionmass=0.1310);
+  Havar->AddElement(W , fractionmass=0.0631);
+
+  //
+  // examples of gas
+  //  
+  new G4Material("ArgonGas", z=18, a=39.948*g/mole, density= 1.782*mg/cm3,
+		 kStateGas, 273.15*kelvin, 1*atmosphere);
 			   
-new G4Material("XenonGas", z=54, a=131.29*g/mole, density= 5.458*mg/cm3,
-                           kStateGas, 293.15*kelvin, 1*atmosphere);
+  new G4Material("XenonGas", z=54, a=131.29*g/mole, density= 5.458*mg/cm3,
+		 kStateGas, 293.15*kelvin, 1*atmosphere);
 			   
-G4Material* CO2 =
-new G4Material("CarbonicGas", density= 1.977*mg/cm3, ncomponents=2);
-CO2->AddElement(C, natoms=1);
-CO2->AddElement(O, natoms=2);
-
-G4Material* ArCO2 =
-new G4Material("ArgonCO2",   density= 1.8223*mg/cm3, ncomponents=2);
-ArCO2->AddElement (Ar,  fractionmass=0.7844);
-ArCO2->AddMaterial(CO2, fractionmass=0.2156);
-
-//another way to define mixture of gas per volume
-G4Material* NewArCO2 =
-new G4Material("NewArgonCO2", density= 1.8223*mg/cm3, ncomponents=3);
-NewArCO2->AddElement (Ar, natoms=8);
-NewArCO2->AddElement (C,  natoms=2);
-NewArCO2->AddElement (O,  natoms=4);
-
-G4Material* ArCH4 = 
-new G4Material("ArgonCH4",    density= 1.709*mg/cm3,  ncomponents=3);
-ArCH4->AddElement (Ar, natoms=93);
-ArCH4->AddElement (C,  natoms=7);
-ArCH4->AddElement (H,  natoms=28);
-
-G4Material* XeCH = 
-new G4Material("XenonMethanePropane", density= 4.9196*mg/cm3, ncomponents=3,
-                                      kStateGas, 293.15*kelvin, 1*atmosphere);
-XeCH->AddElement (Xe, natoms=875);
-XeCH->AddElement (C,  natoms=225);
-XeCH->AddElement (H,  natoms=700);
-
-G4Material* steam = 
-new G4Material("WaterSteam", density= 1.0*mg/cm3, ncomponents=1);
-steam->AddMaterial(H2O, fractionmass=1.);
-steam->GetIonisation()->SetMeanExcitationEnergy(71.6*eV);  
-
-//
-// example of vacuum
-//
-
-density     = universe_mean_density;    //from PhysicalConstants.h
-pressure    = 3.e-18*pascal;
-temperature = 2.73*kelvin;
-new G4Material("Galactic", z=1, a=1.01*g/mole,density,
-                                              kStateGas,temperature,pressure);
+  G4Material* CO2 =
+    new G4Material("CarbonicGas", density= 1.977*mg/cm3, ncomponents=2);
+  CO2->AddElement(C, natoms=1);
+  CO2->AddElement(O, natoms=2);
+
+  G4Material* ArCO2 =
+    new G4Material("ArgonCO2",   density= 1.8223*mg/cm3, ncomponents=2);
+  ArCO2->AddElement (Ar,  fractionmass=0.7844);
+  ArCO2->AddMaterial(CO2, fractionmass=0.2156);
+
+  //another way to define mixture of gas per volume
+  G4Material* NewArCO2 =
+    new G4Material("NewArgonCO2", density= 1.8223*mg/cm3, ncomponents=3);
+  NewArCO2->AddElement (Ar, natoms=8);
+  NewArCO2->AddElement (C,  natoms=2);
+  NewArCO2->AddElement (O,  natoms=4);
+
+  G4Material* ArCH4 = 
+    new G4Material("ArgonCH4",    density= 1.709*mg/cm3,  ncomponents=3);
+  ArCH4->AddElement (Ar, natoms=93);
+  ArCH4->AddElement (C,  natoms=7);
+  ArCH4->AddElement (H,  natoms=28);
+
+  G4Material* XeCH = 
+    new G4Material("XenonMethanePropane", density= 4.9196*mg/cm3, ncomponents=3,
+		   kStateGas, 293.15*kelvin, 1*atmosphere);
+  XeCH->AddElement (Xe, natoms=875);
+  XeCH->AddElement (C,  natoms=225);
+  XeCH->AddElement (H,  natoms=700);
+
+  G4Material* steam = 
+    new G4Material("WaterSteam", density= 1.0*mg/cm3, ncomponents=1);
+  steam->AddMaterial(H2O, fractionmass=1.);
+  steam->GetIonisation()->SetMeanExcitationEnergy(71.6*eV);  
+
+  //
+  // example of vacuum
+  //
+
+  density     = universe_mean_density;    //from PhysicalConstants.h
+  pressure    = 3.e-18*pascal;
+  temperature = 2.73*kelvin;
+  new G4Material("Galactic", z=1, a=1.01*g/mole,density,
+		 kStateGas,temperature,pressure);
 }
 
@@ -300,5 +302,5 @@
                                 0);                //copy number
                                         
-   PrintCalorParameters();         
+  PrintCalorParameters();         
   
   //always return the physical World
@@ -336,5 +338,9 @@
     G4NistManager::Instance()->FindOrBuildMaterial(materialChoice);
 
-  if (pttoMaterial) AbsorberMaterial = pttoMaterial;                  
+  if (pttoMaterial && AbsorberMaterial != pttoMaterial) {
+    AbsorberMaterial = pttoMaterial;                  
+    if(logicAbsorber) logicAbsorber->SetMaterial(AbsorberMaterial);
+    G4RunManager::GetRunManager()->PhysicsHasBeenModified();
+  }
 }
 
@@ -347,5 +353,9 @@
     G4NistManager::Instance()->FindOrBuildMaterial(materialChoice);
 
-  if (pttoMaterial) WorldMaterial = pttoMaterial;
+  if (pttoMaterial && WorldMaterial != pttoMaterial) {
+    WorldMaterial = pttoMaterial;                  
+    if(logicWorld) logicWorld->SetMaterial(WorldMaterial);
+    G4RunManager::GetRunManager()->PhysicsHasBeenModified();
+  }
 }
     
@@ -355,4 +365,5 @@
 {
   AbsorberThickness = val;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -362,4 +373,5 @@
 {
   AbsorberSizeYZ = val;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -370,4 +382,5 @@
   WorldSizeX = val;
   defaultWorld = false;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -378,4 +391,5 @@
   WorldSizeYZ = val;
   defaultWorld = false;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -385,4 +399,5 @@
 {
   XposAbs  = val;
+  G4RunManager::GetRunManager()->GeometryHasBeenModified();
 }  
 
@@ -412,8 +427,7 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo.....
 
-#include "G4RunManager.hh" 
- 
 void DetectorConstruction::UpdateGeometry()
 {
+  G4RunManager::GetRunManager()->PhysicsHasBeenModified();
   G4RunManager::GetRunManager()->DefineWorldVolume(ConstructCalorimeter());
 }
Index: trunk/examples/extended/electromagnetic/TestEm5/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.4 2006/06/29 16:55:32 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm5/src/EventAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/EventAction.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: EventAction.cc,v 1.6 2006/06/29 16:55:34 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: EventAction.cc,v 1.7 2009/03/06 18:04:23 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm5/src/EventMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/EventMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/EventMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventMessenger.cc,v 1.5 2006/06/29 16:55:36 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm5/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/HistoManager.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/HistoManager.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.cc,v 1.21 2007/11/28 12:37:56 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoManager.cc,v 1.26 2008/09/13 17:05:40 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -54,6 +54,6 @@
  
   fileName[0] = "testem5";
-  fileType    = "hbook";
-  fileOption  = "--noErrors uncompress";  
+  fileType    = "root";
+  fileOption  = "--noErrors export=root uncompress";  
   // histograms
   for (G4int k=0; k<MaxHisto; k++) {
@@ -199,5 +199,5 @@
 		  "dummy","dummy","dummy","dummy","dummy","dummy",	//34-39
 		  "(reflect , neutral) : kinetic energy at exit",	//40
-		  "(reflect , neutral) : ener fluence: dE(MeV)/dOmega"	//41
+		  "(reflect , neutral) : ener fluence: dE(MeV)/dOmega",	//41
 		  "(reflect , neutral) : space angle: dN/dOmega",	//42
 		  "(reflect , neutral) : projected angle at exit",	//43
@@ -245,7 +245,21 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
+void HistoManager::Scale(G4int ih, G4double fac)
+{
+ if (ih > MaxHisto) {
+    G4cout << "---> warning from HistoManager::Scale() : histo " << ih
+           << "does not exist.  (fac = " << fac << ")" << G4endl;
+    return;
+  }
+#ifdef G4ANALYSIS_USE
+  if(exist[ih]) histo[ih]->scale(fac);
+#endif
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
 void HistoManager::PrintHisto(G4int ih)
 {
- if (ih < MaxHisto) ascii[ih] = true;
+ if (ih < MaxHisto) { ascii[ih] = true; ascii[0] = true; }
  else
     G4cout << "---> warning from HistoManager::PrintHisto() : histo " << ih
@@ -260,4 +274,6 @@
 {
 #ifdef G4ANALYSIS_USE
+
+ if (!ascii[0]) return;
  
  G4String name = fileName[0] + ".ascii";
@@ -273,5 +289,6 @@
       for (G4int iBin=0; iBin<Nbins[ih]; iBin++) {
          File << "  " << iBin << "\t" 
-              << histo[ih]->binMean(iBin) << "\t"
+              << 0.5*(histo[ih]->axis().binLowerEdge(iBin) +
+	              histo[ih]->axis().binUpperEdge(iBin)) << "\t"	      
 	      << histo[ih]->binHeight(iBin) 
 	      << G4endl;
Index: trunk/examples/extended/electromagnetic/TestEm5/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/HistoMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/HistoMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoMessenger.cc,v 1.8 2007/11/12 17:48:16 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm5/src/PhysListEmStandard.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/PhysListEmStandard.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/PhysListEmStandard.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysListEmStandard.cc,v 1.14 2007/11/21 17:41:19 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: PhysListEmStandard.cc,v 1.24 2009/11/15 22:10:03 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -38,16 +38,23 @@
 #include "G4PhotoElectricEffect.hh"
 
-#include "G4MultipleScattering.hh"
-
+#include "G4eMultipleScattering.hh"
+#include "G4UrbanMscModel93.hh"
 #include "G4eIonisation.hh"
 #include "G4eBremsstrahlung.hh"
 #include "G4eplusAnnihilation.hh"
 
+#include "G4MuMultipleScattering.hh"
 #include "G4MuIonisation.hh"
 #include "G4MuBremsstrahlung.hh"
 #include "G4MuPairProduction.hh"
 
+#include "G4hMultipleScattering.hh"
 #include "G4hIonisation.hh"
+#include "G4hBremsstrahlung.hh"
+#include "G4hPairProduction.hh"
+
 #include "G4ionIonisation.hh"
+#include "G4IonParametrisedLossModel.hh"
+#include "G4NuclearStopping.hh"
 
 #include "G4EmProcessOptions.hh"
@@ -86,33 +93,57 @@
     } else if (particleName == "e-") {
       //electron
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4eIonisation,        -1, 2,2);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 3,3);
+      G4eMultipleScattering* msc = new G4eMultipleScattering();
+      msc->AddEmModel(0, new G4UrbanMscModel93());
+      pmanager->AddProcess(msc,                       -1, 1, 1);      
+      pmanager->AddProcess(new G4eIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4eBremsstrahlung,     -1, 3, 3);
 	    
     } else if (particleName == "e+") {
       //positron
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4eIonisation,        -1, 2,2);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 3,3);
-      pmanager->AddProcess(new G4eplusAnnihilation,   0,-1,4);
+      G4eMultipleScattering* msc = new G4eMultipleScattering();
+      msc->AddEmModel(0, new G4UrbanMscModel93());
+      pmanager->AddProcess(msc,                       -1, 1, 1);            
+      pmanager->AddProcess(new G4eIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4eBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4eplusAnnihilation,    0,-1, 4);
             
     } else if (particleName == "mu+" || 
                particleName == "mu-"    ) {
       //muon  
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4MuIonisation,       -1, 2,2);
-      pmanager->AddProcess(new G4MuBremsstrahlung,   -1, 3,3);
-      pmanager->AddProcess(new G4MuPairProduction,   -1, 4,4);
+      pmanager->AddProcess(new G4MuMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4MuIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4MuBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4MuPairProduction,     -1, 4, 4);
              
-    } else if (particleName == "alpha" || particleName == "GenericIon" ) { 
-      pmanager->AddProcess(new G4MultipleScattering, -1, 1,1);
-      pmanager->AddProcess(new G4ionIonisation,      -1, 2,2);
+    } else if( particleName == "proton" ||
+               particleName == "pi-" ||
+               particleName == "pi+"    ) {
+      //proton  
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,         -1, 2, 2);
+      pmanager->AddProcess(new G4hBremsstrahlung,     -1, 3, 3);
+      pmanager->AddProcess(new G4hPairProduction,     -1, 4, 4);       
      
+    } else if( particleName == "alpha" || 
+	       particleName == "He3"    ) {
+      //alpha 
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4ionIonisation,       -1, 2, 2);
+      pmanager->AddProcess(new G4NuclearStopping,     -1, 3,-1);
+            
+    } else if( particleName == "GenericIon" ) {
+      //Ions 
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      G4ionIonisation* ionIoni = new G4ionIonisation();
+      ionIoni->SetEmModel(new G4IonParametrisedLossModel());
+      pmanager->AddProcess(ionIoni,                   -1, 2, 2);      
+      pmanager->AddProcess(new G4NuclearStopping,     -1, 3,-1);      
+      
     } else if ((!particle->IsShortLived()) &&
 	       (particle->GetPDGCharge() != 0.0) && 
 	       (particle->GetParticleName() != "chargedgeantino")) {
       //all others charged particles except geantino
-      pmanager->AddProcess(new G4MultipleScattering, -1,1,1);
-      pmanager->AddProcess(new G4hIonisation,        -1,2,2);
+      pmanager->AddProcess(new G4hMultipleScattering, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,         -1, 2, 2);
     }
   }
@@ -120,26 +151,32 @@
   // Em options
   //
+  // Main options and setting parameters are shown here.
+  // Several of them have default values.
+  //
   G4EmProcessOptions emOptions;
-    
-  //coulomb scattering
-  //
-  emOptions.SetMscStepLimitation(fUseDistanceToBoundary);   
-  emOptions.SetSkin(4.);
   
   //physics tables
   //
-  emOptions.SetMinEnergy(100*eV);    
-  emOptions.SetMaxEnergy(100*TeV);  
-  emOptions.SetDEDXBinning(1200);  
-  emOptions.SetLambdaBinning(1200);  
-  
+  emOptions.SetMinEnergy(100*eV);	//default    
+  emOptions.SetMaxEnergy(100*TeV);	//default  
+  emOptions.SetDEDXBinning(12*20);	//default=12*7
+  emOptions.SetLambdaBinning(12*20);	//default=12*7
+  emOptions.SetSplineFlag(true);	//default
+      
+  //multiple coulomb scattering
+  //
+  emOptions.SetMscStepLimitation(fUseDistanceToBoundary);  //default=fUseSafety
+  emOptions.SetMscRangeFactor(0.04);	//default
+  emOptions.SetMscGeomFactor (2.5);	//default       
+  emOptions.SetSkin(3.);		//default
+      
   //energy loss
   //
-  emOptions.SetLinearLossLimit(1.e-6);
-  emOptions.SetStepFunction(0.2, 100*um); 
+  emOptions.SetStepFunction(0.2, 100*um);	//default=(0.2, 1*mm)   
+  emOptions.SetLinearLossLimit(1.e-2);		//default
    
   //ionization
   //
-  emOptions.SetSubCutoff(false);  
+  emOptions.SetSubCutoff(false);	//default
 }
 
Index: trunk/examples/extended/electromagnetic/TestEm5/src/PhysListEmStandardSS.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm5/src/PhysListEmStandardSS.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm5/src/PhysListEmStandardSS.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysListEmStandardSS.cc,v 1.3 2007/07/31 16:51:29 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysListEmStandardSS.cc,v 1.6 2008/11/16 18:51:42 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -31,4 +31,5 @@
 
 #include "PhysListEmStandardSS.hh"
+
 #include "G4ParticleDefinition.hh"
 #include "G4ProcessManager.hh"
@@ -38,5 +39,5 @@
 #include "G4PhotoElectricEffect.hh"
 
-#include "G4MultipleScattering.hh"
+#include "G4CoulombScattering.hh"
 
 #include "G4eIonisation.hh"
@@ -50,5 +51,6 @@
 #include "G4hIonisation.hh"
 #include "G4ionIonisation.hh"
-#include "G4CoulombScattering.hh"
+
+#include "G4EmProcessOptions.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -83,33 +85,32 @@
     } else if (particleName == "e-") {
       //electron
-      pmanager->AddProcess(new G4eIonisation,        -1, 1,1);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 2,2);
-      pmanager->AddDiscreteProcess(new G4CoulombScattering);      
+      pmanager->AddDiscreteProcess(new G4CoulombScattering);            
+      pmanager->AddProcess(new G4eIonisation,        -1, 1, 1);
+      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 2, 2);
 	    
     } else if (particleName == "e+") {
       //positron
-      pmanager->AddProcess(new G4eIonisation,        -1, 1,1);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 2,2);
-      pmanager->AddProcess(new G4eplusAnnihilation,   0,-1,3);
-      pmanager->AddDiscreteProcess(new G4CoulombScattering);      
+      pmanager->AddDiscreteProcess(new G4CoulombScattering);            
+      pmanager->AddProcess(new G4eIonisation,        -1, 1, 1);
+      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 2, 2);
+      pmanager->AddProcess(new G4eplusAnnihilation,   0,-1, 3);
             
     } else if (particleName == "mu+" || 
                particleName == "mu-"    ) {
-      //muon  
-      pmanager->AddProcess(new G4MuIonisation,       -1, 1,1);
-      pmanager->AddProcess(new G4MuBremsstrahlung,   -1, 2,2);
-      pmanager->AddProcess(new G4MuPairProduction,   -1, 3,3);
-      pmanager->AddDiscreteProcess(new G4CoulombScattering);      
+      //muon
+      pmanager->AddDiscreteProcess(new G4CoulombScattering);              
+      pmanager->AddProcess(new G4MuIonisation,       -1, 1, 1);
+      pmanager->AddProcess(new G4MuBremsstrahlung,   -1, 2, 2);
+      pmanager->AddProcess(new G4MuPairProduction,   -1, 3, 3);
              
     } else if (particleName == "alpha" || particleName == "He3") {
-      pmanager->AddProcess(new G4ionIonisation,      -1, 1,1);
-      pmanager->AddDiscreteProcess(new G4CoulombScattering);      
+      pmanager->AddDiscreteProcess(new G4CoulombScattering);          
+      pmanager->AddProcess(new G4ionIonisation,      -1, 1, 1);
 
     } else if (particleName == "GenericIon" ) { 
-      pmanager->AddProcess(new G4ionIonisation,      -1, 1,1);
       G4CoulombScattering* cs = new G4CoulombScattering();
       cs->SetBuildTableFlag(false);
       pmanager->AddDiscreteProcess(cs);
-      
+      pmanager->AddProcess(new G4ionIonisation,      -1, 1, 1);      
      
     } else if ((!particle->IsShortLived()) &&
@@ -117,8 +118,32 @@
 	       (particle->GetParticleName() != "chargedgeantino")) {
       //all others charged particles except geantino
-      pmanager->AddProcess(new G4hIonisation,        -1,1,1);
-      pmanager->AddDiscreteProcess(new G4CoulombScattering);      
+      pmanager->AddDiscreteProcess(new G4CoulombScattering);            
+      pmanager->AddProcess(new G4hIonisation,        -1, 1, 1);
     }
   }
+  
+  // Em options
+  //
+  // Main options and setting parameters are shown here.
+  // Several of them have default values.
+  //
+  G4EmProcessOptions emOptions;
+  
+  //physics tables
+  //
+  emOptions.SetMinEnergy(100*eV);	//default    
+  emOptions.SetMaxEnergy(100*TeV);	//default  
+  emOptions.SetDEDXBinning(12*20);	//default=12*7  
+  emOptions.SetLambdaBinning(12*20);	//default=12*7
+  emOptions.SetSplineFlag(true);	//default
+      
+  //energy loss
+  //
+  emOptions.SetStepFunction(0.2, 100*um);	//default=(0.2, 1*mm)      
+  emOptions.SetLinearLossLimit(1.e-2);		//default
+   
+  //ionization
+  //
+  emOptions.SetSubCutoff(false);	//default  
 }
 
